## far2l-core 2.6.5

=== CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
include(${CMAKE_SOURCE_DIR}/cmake/FuncCopyResources.cmake)

cmake_minimum_required (VERSION 3.5.0)

project (far2l)

set(APP_NAME "far2l")
set(APP_IDENTIFIER "com.far2l")
set(CPACK_PACKAGE_NAME "far2l")

string(ASCII 27 Esc)
set(ColorNormal "${Esc}[m")
set(ColorRed "${Esc}[1;31m")

include(GNUInstallDirs)

# just to force reconfigure if packaging/version changed
configure_file(${CMAKE_SOURCE_DIR}/packaging/version ${CMAKE_BINARY_DIR}/packaging/version @ONLY)

# reconfigure in case .git directory changed to update version correctly
IF(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS ${CMAKE_SOURCE_DIR}/.git)
endif()

file(READ "${CMAKE_SOURCE_DIR}/packaging/version" VERSION)
string(REGEX REPLACE "[\r\n\t ]$" "" VERSION "${VERSION}")
string(REGEX REPLACE "^([0-9]+)\\..*" "\\1" VERSION_MAJOR "${VERSION}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*" "\\1" VERSION_MINOR "${VERSION}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.(.*)" "\\1" VERSION_PATCH "${VERSION}")

if("${VERSION_MAJOR}" STREQUAL "" OR "${VERSION_MAJOR}" STREQUAL "${VERSION}"
    OR "${VERSION_MINOR}" STREQUAL "" OR "${VERSION_MINOR}" STREQUAL "${VERSION}"
    OR "${VERSION_PATCH}" STREQUAL "" OR "${VERSION_PATCH}" STREQUAL "${VERSION}")
        message(FATAL_ERROR "${ColorRed}packaging/version is corrupted, please write actual X.Y.Z version into it.${ColorNormal}")
endif()

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tag
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_TAG
        OUTPUT_STRIP_TRAILING_WHITESPACE
        ERROR_QUIET)
endif()

if(NOT "${GIT_TAG}" STREQUAL "v_${VERSION}")
    if(GIT_FOUND)
        if(IS_DIRECTORY ${CMAKE_SOURCE_DIR}/.git)
            execute_process(COMMAND "${GIT_EXECUTABLE}" show --no-patch --format=%ci HEAD
                WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                OUTPUT_VARIABLE GIT_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
            string(SUBSTRING ${GIT_DATE} 0 10 GIT_DATE)
            execute_process(COMMAND "${GIT_EXECUTABLE}" rev-parse --short HEAD
                WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                OUTPUT_VARIABLE GIT_HASH
                OUTPUT_STRIP_TRAILING_WHITESPACE)
        endif()
    endif()
    if(NOT "${GIT_DATE}" STREQUAL "")
        message(STATUS "git date: ${GIT_DATE}")
        set(VERSION_PATCH "${VERSION_PATCH}-${GIT_DATE}")
    endif()
    if(NOT "${GIT_HASH}" STREQUAL "")
        message(STATUS "git hash: ${GIT_HASH}")
        set(VERSION_PATCH "${VERSION_PATCH}-${GIT_HASH}")
    else()
        message(WARNING "git information unavailable, assuming its a build from v_${VERSION}")
    endif()
endif()

set(VERSION_PATCH "${VERSION_PATCH}-beta")

set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
endif()

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE} Version: ${VERSION}")

if(NOT DEFINED CMAKE_INSTALL_PREFIX)
   if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
      set(CMAKE_INSTALL_PREFIX "/usr/local")
   elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
      set(CMAKE_INSTALL_PREFIX "/usr/local")
   else()
      set(CMAKE_INSTALL_PREFIX "/usr")
   endif()
endif()

##############################

if (NOT DEFINED TESTING)
    set(TESTING "NO")
endif()

if (NOT DEFINED USEWX)
    set(USEWX "YES")
endif()

if (NOT DEFINED UNRAR)
    set(UNRAR "bundled")
endif()

# EACP disabled by default for now as FAR's GetCodePageInfo rejects all multibyte charsets due to BUGBUG.
# Uncomment EACP-stuff here when that will be fixed. See https://github.com/elfmz/far2l/issues/1179
#if (NOT DEFINED EACP)
#   set(EACP "YES")
#endif()

if (NOT DEFINED LEGACY)
    # TODO: default it to NO  somewhere in 2022, after all obsolete settings
    # registry-upgrade-to-ini stuff will be safe to remove
    set(LEGACY "YES")
elseif(FARFTP)
    set(LEGACY "YES")
    message(STATUS "Force-enable LEGACY due to enabled FARFTP")
endif()

#if (NOT EACP)
#   message(STATUS "${ColorRed}Building without East Asian codepages support due to EACP=${EACP}${ColorNormal}")
#endif()

# set(RM rm) actually not needed: use $(CMAKE_COMMAND) -E remove

if(MUSL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__MUSL__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__MUSL__")
endif()

if(TAR_LIMITED_ARGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__TAR_LIMITED_ARGS__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__TAR_LIMITED_ARGS__")
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.1.0")
    message("Please consider to switch to newer CMake")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
endif()

if("${ICU_MODE}" STREQUAL "runtime")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DRUNTIME_ICU")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DRUNTIME_ICU")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -Wno-unused-function -D_FILE_OFFSET_BITS=64") #  -fsanitize=address
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=c99 -fPIC -Wno-unused-function -D_FILE_OFFSET_BITS=64") #  -fsanitize=address

set(CMAKE_CXX_FLAGS_RELEASE "-O2")
set(CMAKE_C_FLAGS_RELEASE "-O2")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DPROCPLUGINMACROFUNC=1")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DPROCPLUGINMACROFUNC=1")

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(APP_DIR ${CMAKE_BINARY_DIR}/install)
    set(INSTALL_DIR ${APP_DIR}/${APP_NAME}.app/Contents/MacOS)
    set(EXECUTABLE_NAME ${APP_NAME})

else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffunction-sections -fdata-sections")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffunction-sections -fdata-sections")
    set(INSTALL_DIR ${CMAKE_BINARY_DIR}/install)
    set(EXECUTABLE_NAME far2l)

    if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--gc-sections")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wl,--gc-sections")
    endif()
endif()

if (CMAKE_SYSTEM_NAME MATCHES "CYGWIN")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE=600")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE=600")
    message(STATUS "Running under cygwin, wow!")
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Haiku")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -D_DEFAULT_SOURCE -Wno-attributes")
endif()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_C_VISIBILITY_PRESET hidden)

if (LEGACY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWINPORT_REGISTRY")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DWINPORT_REGISTRY")
    message(STATUS "Enabling registry support due to enabled LEGACY")
else()
    message(STATUS "LEGACY is not enabled, your old registry settings will be forgotten, if any")
endif()

if(CMAKE_VERSION VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
    cmake_policy(SET CMP0057 NEW)
endif()

include_directories(utils/include)

add_subdirectory (WinPort)
add_subdirectory (utils)
add_subdirectory (far2l)

if (NOT ${USEWX})
    message(STATUS "Building without GUI/wxWidgets backend due to USEWX=${USEWX}")
else()
    message(STATUS "Building with GUI/wxWidgets backend")
    if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
        if (DEFINED wxWidgets_CONFIG_EXECUTABLE)
            message(STATUS "Using pre-defined wx config: ${wxWidgets_CONFIG_EXECUTABLE}")

        elseif(EXISTS "/usr/local/bin/wxgtk3u-3.2-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.2-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.2")
            message(STATUS "Using known location of wx-config 3.2")

        elseif(EXISTS "/usr/local/bin/wxgtk3u-3.1-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.1-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.1")
            message(STATUS "Using known location of wx-config 3.1")

        elseif (EXISTS "/usr/local/bin/wxgtk3u-3.0-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.0-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.0")
            message(STATUS "Using known location of wx-config 3.0")

        else()
            message(STATUS "No wxgtk3u-3.*-config in expected locations")
        endif()

    elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        if (DEFINED wxWidgets_CONFIG_EXECUTABLE)
            message(STATUS "Using pre-defined wx config: ${wxWidgets_CONFIG_EXECUTABLE}")

        elseif (EXISTS "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wx-config")
            # MacPorts
            set(wxWidgets_CONFIG_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wx-config")
            set(wxWidgets_wxrc_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wxrc")
            message(STATUS "Using known location of wx-config 3.2")

        elseif (EXISTS "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wx-config")
            # MacPorts
            set(wxWidgets_CONFIG_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wx-config")
            set(wxWidgets_wxrc_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wxrc")
            message(STATUS "Using known location of wx-config 3.1")

        else()
            message(STATUS "No wx-config in expected locations")
        endif()
    endif()

    add_subdirectory(WinPort/src/Backend/WX)
endif()

if (NOT DEFINED TTYX)
    find_package(X11)
    if(X11_FOUND)
        message(STATUS "Building with TTY X11 extensions due to X11 found")
        add_subdirectory(WinPort/src/Backend/TTY/TTYX)
    else()
        message(STATUS "Building without TTY X11 extensions due to X11 not found")
    endif()
elseif (TTYX)
    message(STATUS "Building with TTY X11 extensions due to TTYX=${TTYX}")
    add_subdirectory(WinPort/src/Backend/TTY/TTYX)
else()
    message(STATUS "Building without TTY X11 extensions due to TTYX=${TTYX}")
endif()


##############################
# plugins directives

if (NOT DEFINED ALIGN OR ALIGN)
    message(STATUS "ALIGN plugin enabled")
    add_subdirectory (align)
else()
    message(STATUS "${ColorRed}ALIGN plugin disabled due to ALIGN=${ALIGN}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/align/plug/align.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED AUTOWRAP OR AUTOWRAP)
    message(STATUS "AUTOWRAP plugin enabled")
    add_subdirectory (autowrap)
else()
    message(STATUS "${ColorRed}AUTOWRAP plugin disabled due to AUTOWRAP=${AUTOWRAP}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/autowrap/plug/autowrap.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED CALC OR CALC)
    message(STATUS "CALC plugin enabled")
    add_subdirectory (calc)
else()
    message(STATUS "${ColorRed}CALC plugin disabled due to CALC=${CALC}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/calc/plug/calc.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED COLORER OR COLORER)
    message(STATUS "COLORER plugin enabled")
    add_subdirectory (colorer)
else()
    message(STATUS "${ColorRed}COLORER plugin disabled due to COLORER=${COLORER}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/colorer/plug/colorer.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED COMPARE OR COMPARE)

=== NetRocks/CMakeLists.txt ===
project(NetRocks)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(SOURCES
src/Erroring.cpp
src/Globals.cpp
src/SitesConfig.cpp
src/NetRocks.cpp
src/PluginImpl.cpp
src/PluginPanelItems.cpp
src/PooledStrings.cpp
src/GetItems.cpp
src/BackgroundTasks.cpp
src/Location.cpp
src/ConnectionsPool.cpp
src/ImportFarFtpSites.cpp
src/Host/HostLocal.cpp
src/Host/HostRemote.cpp
src/Host/InitDeinitCmd.cpp
src/UI/DialogUtils.cpp
src/UI/Settings/ConfigurePlugin.cpp
src/UI/Settings/SiteConnectionEditor.cpp
src/UI/Settings/ExtraSiteSettings.cpp
src/UI/Settings/ProxySettings.cpp
src/UI/Settings/ConfigureProtocolSFTPSCP.cpp
src/UI/Settings/ConfigureProtocolFTP.cpp
src/UI/Settings/ConfigureProtocolAWS.cpp
src/UI/Settings/ConfigureProtocolSMB.cpp
src/UI/Settings/ConfigureProtocolNFS.cpp
src/UI/Settings/ConfigureProtocolWebDAV.cpp
src/UI/Settings/ConfigureProtocolSHELL.cpp
src/Protocol/SHELL/WayToShellConfig.cpp
src/UI/Activities/Confirm.cpp
src/UI/Activities/ConfirmXfer.cpp
src/UI/Activities/ConfirmOverwrite.cpp
src/UI/Activities/ConfirmChangeMode.cpp
src/UI/Activities/SimpleOperationProgress.cpp
src/UI/Activities/ComplexOperationProgress.cpp
src/UI/Activities/AbortOperationRequest.cpp
src/UI/Activities/InteractiveLogin.cpp
src/UI/Activities/ConfirmNewServerIdentity.cpp
src/UI/Activities/WhatOnError.cpp
src/UI/Activities/BackgroundTasksUI.cpp
src/Op/Utils/ProgressStateUpdate.cpp
src/Op/Utils/Enumer.cpp
src/Op/Utils/IOBuffer.cpp
src/Op/OpBase.cpp
src/Op/OpConnect.cpp
src/Op/OpCheckDirectory.cpp
src/Op/OpChangeMode.cpp
src/Op/OpEnumDirectory.cpp
src/Op/OpXfer.cpp
src/Op/OpRemove.cpp
src/Op/OpMakeDirectory.cpp
src/Op/OpExecute.cpp
src/Op/OpGetLinkTarget.cpp
src/Protocol/SplitLocationSpecification.cpp
src/Protocol/Protocol.cpp
)


set(PROTOCOL_SOURCES
src/Erroring.cpp
src/Host/HostRemoteBroker.cpp
)

add_executable (NetRocks-FILE
    ${PROTOCOL_SOURCES}
    src/Protocol/File/ProtocolFile.cpp
    src/Host/HostLocal.cpp
)

add_executable (NetRocks-SHELL
    ${PROTOCOL_SOURCES}
    src/Protocol/SHELL/ProtocolSHELL.cpp
    src/Protocol/SHELL/ProtocolSHELL_ExecCmd.cpp
    src/Protocol/SHELL/WayToShellConfig.cpp
    src/Protocol/SHELL/WayToShell.cpp
    src/Protocol/SHELL/Request.cpp
    src/Protocol/SHELL/Parse.cpp
    src/Protocol/SHELL/RemoteSh.cpp
    src/Protocol/ShellParseUtils.cpp
)

target_link_libraries(NetRocks-FILE utils)
target_include_directories(NetRocks-FILE PRIVATE src)
set_target_properties(NetRocks-FILE
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
    PREFIX ""
    SUFFIX ".broker")
target_compile_options(NetRocks-FILE PUBLIC -DNETROCKS_PROTOCOL)

target_link_libraries(NetRocks-SHELL utils)
target_include_directories(NetRocks-SHELL PRIVATE src)
set_target_properties(NetRocks-SHELL
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
    PREFIX ""
    SUFFIX ".broker")
target_compile_options(NetRocks-SHELL PUBLIC -DNETROCKS_PROTOCOL)

# copy resource files
set(CURRENT_TARGET "NetRocks-SHELL")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/src/Protocol/SHELL/Helpers
        "${CMAKE_CURRENT_SOURCE_DIR}/src/Protocol/SHELL/Helpers/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/src/Protocol/SHELL/Helpers
        "${INSTALL_DIR}/Plugins/NetRocks/plug/SHELL/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

if (LIBSSH_FOUND AND ((NOT DEFINED NR_SFTP) OR NR_SFTP))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_SFTP")
    add_executable (NetRocks-SFTP
        ${PROTOCOL_SOURCES}
        src/Protocol/SSH/SSHConnection.cpp
        src/Protocol/SSH/ProtocolSFTP.cpp
        src/Protocol/SSH/ProtocolSCP.cpp
        src/Protocol/FileStatsOverride.cpp
        src/Protocol/ShellParseUtils.cpp
    )
    target_link_libraries(NetRocks-SFTP utils ${LIBSSH_LIBRARIES})
    target_include_directories(NetRocks-SFTP PRIVATE src ${LIBSSH_INCLUDE_DIRS})
    # all ssh_scp_* functions are deprecated. It is recommended to use SFTP. Warnings are disabled
    target_compile_options(NetRocks-SFTP PUBLIC -Wno-deprecated-declarations)
    set_target_properties(NetRocks-SFTP
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (LIBSMBCLIENT_FOUND AND ((NOT DEFINED NR_SMB) OR NR_SMB))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_SMB")
    add_executable (NetRocks-SMB
        ${PROTOCOL_SOURCES}
        src/Protocol/SMB/ProtocolSMB.cpp
        src/Protocol/SMB/NMBEnum.cpp
    )
    target_link_libraries(NetRocks-SMB utils ${LIBSMBCLIENT_LIBRARIES})
    target_include_directories(NetRocks-SMB PRIVATE src ${LIBSMBCLIENT_INCLUDE_DIRS})
    target_compile_options(NetRocks-SMB PUBLIC -Wno-deprecated-declarations)
    set_target_properties(NetRocks-SMB
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (LIBNFS_FOUND AND ((NOT DEFINED NR_NFS) OR NR_NFS))
    if(NOT DEFINED OLD_NFSLIB)
        set(OLD_NFSLIB "0")
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_NFS -DUSE_OLD_NFSLIB=${OLD_NFSLIB}")
    add_executable (NetRocks-NFS
        ${PROTOCOL_SOURCES}
        src/Protocol/NFS/ProtocolNFS.cpp
    )
    target_link_libraries(NetRocks-NFS utils ${LIBNFS_LIBRARIES})
    find_package(GnuTLS)
    if (GNUTLS_FOUND)
        target_link_libraries(NetRocks-NFS ${GNUTLS_LIBRARIES})
    endif ()
    target_include_directories(NetRocks-NFS PRIVATE src ${LIBNFS_INCLUDE_DIRS})
    set_target_properties(NetRocks-NFS
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()


if (LIBNEON_FOUND AND ((NOT DEFINED NR_WEBDAV) OR NR_WEBDAV))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_WEBDAV")
    add_executable (NetRocks-WebDAV
        ${PROTOCOL_SOURCES}
        src/Protocol/WebDAV/ProtocolWebDAV.cpp
    )
    target_link_libraries(NetRocks-WebDAV utils ${LIBNEON_LIBRARIES})
    target_include_directories(NetRocks-WebDAV PRIVATE src ${LIBNEON_INCLUDE_DIRS})
    set_target_properties(NetRocks-WebDAV
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (AWSSDK_FOUND AND ((NOT DEFINED NR_AWS) OR NR_AWS))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_AWS")
    add_executable (NetRocks-AWS
        ${PROTOCOL_SOURCES}
        src/Protocol/AWS/AWSFile.cpp
        src/Protocol/AWS/AWSFileWriter.cpp
        src/Protocol/AWS/AWSFileReader.cpp
        src/Protocol/AWS/S3Repository.cpp
        src/Protocol/AWS/ProtocolAWS.cpp
    )
    target_include_directories(NetRocks-AWS PRIVATE src ${AWSSDK_INCLUDE_DIR})
    target_link_libraries(NetRocks-AWS utils ${AWSSDK_LINK_LIBRARIES})

    set_target_properties(NetRocks-AWS
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

    add_executable (NetRocks-FTP
        ${PROTOCOL_SOURCES}
        src/Protocol/FTP/ProtocolFTP.cpp
        src/Protocol/FTP/FTPConnection.cpp
        src/Protocol/FTP/FTPParseMLST.cpp
        src/Protocol/FTP/FTPParseLIST.cpp
        src/Protocol/DirectoryEnumCache.cpp
    )
    target_link_libraries(NetRocks-FTP utils)
    target_include_directories(NetRocks-FTP PRIVATE src)
if (OPENSSL_FOUND AND ((NOT DEFINED NR_OPENSSL) OR NR_OPENSSL))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_OPENSSL")
    target_link_libraries(NetRocks-FTP ${OPENSSL_LIBRARIES})
    target_include_directories(NetRocks-FTP PRIVATE ${OPENSSL_INCLUDE_DIR})
endif ()
    set_target_properties(NetRocks-FTP
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FAR_HAS_NAMELESS_UNIONS")

add_library (NetRocks MODULE ${SOURCES})

target_link_libraries(NetRocks utils far2l)

target_include_directories(NetRocks PRIVATE src)
target_include_directories(NetRocks PRIVATE ../WinPort)
target_include_directories(NetRocks PRIVATE ../far2l/far2sdk)

target_compile_definitions(NetRocks PRIVATE)

set_target_properties(NetRocks
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "NetRocks")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== OpenWith/CMakeLists.txt ===
project(OpenWith)

set(SOURCES
src/OpenWith.cpp
src/AppProvider.cpp
src/DummyAppProvider.cpp
src/XDGBasedAppProvider.cpp
)

if(APPLE)
    list(APPEND SOURCES src/MacOSAppProvider.mm)
endif()

add_library (${PROJECT_NAME} MODULE ${SOURCES})
target_link_libraries(${PROJECT_NAME} utils far2l)

# Frameworks for macOS
if(APPLE)
    target_link_libraries(${PROJECT_NAME}
        "-framework Cocoa"
        "-framework CoreServices"
        "-framework UniformTypeIdentifiers"
    )
    target_compile_options(${PROJECT_NAME} PRIVATE "-fobjc-arc")
endif()

target_compile_definitions(OpenWith PRIVATE)

target_include_directories(${PROJECT_NAME} PRIVATE .)
target_include_directories(${PROJECT_NAME} PRIVATE ../far2l/far2sdk)
target_include_directories(${PROJECT_NAME} PRIVATE ../WinPort)
target_include_directories(${PROJECT_NAME} PRIVATE ../utils/include)

set_target_properties(${PROJECT_NAME} PROPERTIES
	LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/${PROJECT_NAME}/plug"
	PREFIX ""
	SUFFIX ".far-plug-wide")

set(CURRENT_TARGET "OpenWith")


file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)

setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/plug"
)

add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== adb/CMakeLists.txt ===
# ADB Plugin for far2l

# Basic source files
set(SOURCES
    src/FARPlugin.cpp
    src/ADBPlugin.cpp
    src/ADBShell.cpp
    src/ADBDevice.cpp
    src/ADBDialogs.cpp
    src/ADBLog.cpp
)

# Create the plugin
add_library(adb MODULE ${SOURCES})

# Link with required libraries
target_link_libraries(adb utils far2l)

# Add compile definitions
target_compile_definitions(adb PRIVATE
    -DWINPORT_DIRECT
    -DUNICODE
    -D_UNICODE
    -DFAR_DONT_USE_INTERNALS
)

# Add include directories
target_include_directories(adb PRIVATE .)
target_include_directories(adb PRIVATE ../far2l/far2sdk)
target_include_directories(adb PRIVATE ../WinPort)

# Set output properties
set_target_properties(adb PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/adb/plug"
    PREFIX ""
    SUFFIX ".far-plug-wide"
)

# Copy resource files
set(CURRENT_TARGET "adb")
file(GLOB_RECURSE RESOURCE_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
    "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
    RESOURCE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/configs
    "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== editwrap/CMakeLists.txt ===

project(far2l-EditWrap)

set(SOURCES
EditWrap.cpp 
)

add_library (far2l-EditWrap MODULE ${SOURCES})

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -flat_namespace -undefined suppress")
endif()

target_link_libraries(far2l-EditWrap utils far2l)

target_compile_definitions(far2l-EditWrap PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(far2l-EditWrap PRIVATE .)
target_include_directories(far2l-EditWrap PRIVATE ../far2l)
target_include_directories(far2l-EditWrap PRIVATE ../far2l/Include)
target_include_directories(far2l-EditWrap PRIVATE ../WinPort)

set_target_properties(far2l-EditWrap
  PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/far2l-EditWrap/plug"
    PREFIX ""
    SUFFIX ".far-plug-wide")


#add_custom_command(TARGET far2l-EditWrap POST_BUILD
#   DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
#   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/far2l-EditWrap"
#)

=== jumpword/CMakeLists.txt ===

project(jumpword)

set(SOURCES
src/JumpWord.cpp 
)

add_library (jumpword MODULE ${SOURCES})

target_link_libraries(jumpword)

target_compile_definitions(jumpword PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(jumpword PRIVATE .)
target_include_directories(jumpword PRIVATE ../far2l/far2sdk)
target_include_directories(jumpword PRIVATE ../WinPort)

set_target_properties(jumpword 
  PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/jumpword/plug"
    PREFIX ""
    SUFFIX ".far-plug-wide")

set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
  $<$<CONFIG:Debug>:_DEBUG>)

add_custom_command(TARGET jumpword POST_BUILD
   DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/jumpword"
)

=== luafar/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)

project(luafar2l)

if (NOT DEFINED USE_LUAJIT OR USE_LUAJIT)
  include_directories("/usr/include/luajit-2.1")
  set(LIB_LUA "luajit-5.1")
  set(LUAEXE  "luajit")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DUSE_LUAJIT")
else()
  include_directories("/usr/include/lua5.1")
  set(LIB_LUA "lua5.1")
  set(LUAEXE  "lua")
endif()

string(REPLACE "-std=c99" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS} -O2")

set(SDK "${CMAKE_SOURCE_DIR}/far2l/far2sdk")

function(GenerateFile trg src script)
  add_custom_command(
      OUTPUT  ${trg}          # Treated as relative to CMAKE_CURRENT_BINARY_DIR
      COMMAND ${LUAEXE} ${CMAKE_CURRENT_SOURCE_DIR}/src/${script} ${SDK}/${src}
              > ${CMAKE_CURRENT_BINARY_DIR}/${trg}
      DEPENDS ${SDK}/${src}
  )
endfunction()

GenerateFile("farkeys.c"  "farkeys.h"      "makefarkeys.lua" )
GenerateFile("farcolor.c" "farcolor.h"     "makefarkeys.lua")
GenerateFile("farflags.c" "farplug-wide.h" "makeflags.lua")

set(SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/farkeys.c
  ${CMAKE_CURRENT_BINARY_DIR}/farcolor.c
  ${CMAKE_CURRENT_BINARY_DIR}/farflags.c
  src/bit64.c
  src/exported.c
  src/lregex.c
  src/luamacro.c
  src/lusercontrol.c
  src/lutf8lib.c
  src/mytimer.c
  src/service.c
  src/slnunico.c
  src/ustring.c
  src/util.c
)

add_library (luafar2l MODULE ${SOURCES})
target_link_libraries(luafar2l ${LIB_LUA} uuid)

target_compile_definitions(luafar2l PRIVATE -DWINPORT_DIRECT -DFAR_USE_INTERNALS)

target_include_directories(luafar2l PRIVATE ../far2l/far2sdk)
target_include_directories(luafar2l PRIVATE ../WinPort)

set_target_properties(luafar2l
  PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/luafar"
    PREFIX ""
    SUFFIX ".so")

=== mtp/CMakeLists.txt ===
# MTP Plugin for far2l

# Basic source files
set(SOURCES
    src/FARPlugin.cpp
    src/MTPPlugin.cpp
    src/MTPDevice.cpp
    src/MTPFileSystem.cpp
    src/MTPLog.cpp
    src/MTPDialogs.cpp
)

# Create the plugin
add_library(mtp MODULE ${SOURCES})

# Link with required libraries
target_link_libraries(mtp utils far2l)

target_link_libraries(mtp 
    -lmtp
)

# Convert version to mumeric form
find_path(LIBMTP_INCLUDE_DIR libmtp.h)
file(READ "${LIBMTP_INCLUDE_DIR}/libmtp.h" LIBMTP_HEADER_CONTENT)
string(REGEX MATCH "#define[ \t]+LIBMTP_VERSION[ \t]+([0-9]+)\\.([0-9]+)\\.([0-9]+)" _match "${LIBMTP_HEADER_CONTENT}")
set(LIBMTP_VERSION_MAJOR "${CMAKE_MATCH_1}")
set(LIBMTP_VERSION_MINOR "${CMAKE_MATCH_2}")
set(LIBMTP_VERSION_PATCH "${CMAKE_MATCH_3}")
math(EXPR LIBMTP_VERSION_CODE "${LIBMTP_VERSION_MAJOR} * 10000 + ${LIBMTP_VERSION_MINOR} * 100 + ${LIBMTP_VERSION_PATCH}")

include(CheckSymbolExists)

set(CMAKE_REQUIRED_INCLUDES ${LIBMTP_INCLUDE_DIR})
check_symbol_exists(LIBMTP_FreeMemory "libmtp.h" HAVE_LIBMTP_FREEMEMORY)

# Add compile definitions
target_compile_definitions(mtp PRIVATE
    -DWINPORT_DIRECT
    -DUNICODE
    -D_UNICODE
    -DFAR_DONT_USE_INTERNALS
    -DLIBMTP_VERSION_CODE=${LIBMTP_VERSION_CODE}
)

if(HAVE_LIBMTP_FREEMEMORY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBMTP_FREEMEMORY")
endif()

# Add include directories
target_include_directories(mtp PRIVATE .)
target_include_directories(mtp PRIVATE ../far2l/far2sdk)
target_include_directories(mtp PRIVATE ../WinPort)

# Set output properties
set_target_properties(mtp PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/mtp/plug"
    PREFIX ""
    SUFFIX ".far-plug-wide"
)

# Copy resource files
set(CURRENT_TARGET "mtp")
file(GLOB_RECURSE RESOURCE_FILES
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
    "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)

# No auxiliary files for MTP plugin yet

=== multiarc/CMakeLists.txt ===

project(multiarc)

set(SOURCES
    src/MultiArc.cpp
    src/ArcPlg.cpp
    src/arccfg.cpp
    src/arcget.cpp
    src/arcput.cpp
    src/ArcMix.cpp
    src/ArcProc.cpp
    src/global.cpp
    src/arcread.cpp
    src/arccmd.cpp
    src/formats/ha/ha.cpp
    src/formats/arj/arj.cpp
    src/formats/ace/ace.cpp
    src/formats/arc/arc.cpp
    src/formats/zip/zip.cpp
    src/formats/lzh/lzh.cpp

        src/formats/7z/C/7zAlloc.c
        src/formats/7z/C/7zArcIn.c
        src/formats/7z/C/7zBuf2.c
        src/formats/7z/C/7zBuf.c
        src/formats/7z/C/7zCrc.c
        src/formats/7z/C/7zCrcOpt.c
        src/formats/7z/C/7zDec.c
        src/formats/7z/C/7zFile.c
        src/formats/7z/C/7zStream.c
        src/formats/7z/C/Aes.c
        src/formats/7z/C/AesOpt.c
        src/formats/7z/C/Alloc.c
        src/formats/7z/C/Bcj2.c
        src/formats/7z/C/Bcj2Enc.c
        src/formats/7z/C/Blake2s.c
        src/formats/7z/C/Bra86.c
        src/formats/7z/C/Bra.c
        src/formats/7z/C/BraIA64.c
        src/formats/7z/C/BwtSort.c
        src/formats/7z/C/CpuArch.c
        src/formats/7z/C/Delta.c
        src/formats/7z/C/DllSecur.c
        src/formats/7z/C/HuffEnc.c
        src/formats/7z/C/LzFind.c
        src/formats/7z/C/LzFindMt.c
        src/formats/7z/C/LzFindOpt.c
        src/formats/7z/C/Lzma2Dec.c
        src/formats/7z/C/Lzma2DecMt.c
        src/formats/7z/C/Lzma2Enc.c
        src/formats/7z/C/Lzma86Dec.c
        src/formats/7z/C/Lzma86Enc.c
        src/formats/7z/C/LzmaDec.c
        src/formats/7z/C/LzmaEnc.c
        src/formats/7z/C/LzmaLib.c
        src/formats/7z/C/Md5.c
        src/formats/7z/C/MtCoder.c
        src/formats/7z/C/MtDec.c
        src/formats/7z/C/Ppmd7aDec.c
        src/formats/7z/C/Ppmd7.c
        src/formats/7z/C/Ppmd7Dec.c
        src/formats/7z/C/Ppmd7Enc.c
        src/formats/7z/C/Ppmd8.c
        src/formats/7z/C/Ppmd8Dec.c
        src/formats/7z/C/Ppmd8Enc.c
        src/formats/7z/C/Sha1.c
        src/formats/7z/C/Sha1Opt.c
        src/formats/7z/C/Sha256.c
        src/formats/7z/C/Sha256Opt.c
        src/formats/7z/C/Sha3.c
        src/formats/7z/C/Sha512.c
        src/formats/7z/C/Sha512Opt.c
        src/formats/7z/C/Sort.c
        src/formats/7z/C/SwapBytes.c
        src/formats/7z/C/Threads.c
        src/formats/7z/C/Xxh64.c
        src/formats/7z/C/Xz.c
        src/formats/7z/C/XzCrc64.c
        src/formats/7z/C/XzCrc64Opt.c
        src/formats/7z/C/XzDec.c
        src/formats/7z/C/XzEnc.c
        src/formats/7z/C/XzIn.c
        src/formats/7z/C/ZstdDec.c
        src/formats/7z/7z.cpp
        src/formats/7z/7zMain.cpp

        src/formats/ha/ha/acoder.c
        src/formats/ha/ha/archive.c
        src/formats/ha/ha/asc.c
        src/formats/ha/ha/cpy.c
        src/formats/ha/ha/error.c
        src/formats/ha/ha/ha.c
        src/formats/ha/ha/haio.c
        src/formats/ha/ha/hsc.c
        src/formats/ha/ha/info.c
        src/formats/ha/ha/machine.c
        src/formats/ha/ha/misc.c
        src/formats/ha/ha/swdict.c
)

if("${UNRAR}" STREQUAL "lib")
    set(SOURCES
        ${SOURCES}
        src/formats/rar/rar.cpp
        src/formats/rar/rarmainstub.cpp
    )
elseif(UNRAR)
    set(RAR_FILES
        src/formats/rar/rar.cpp
        src/formats/rar/unrar/scantree.cpp
        src/formats/rar/unrar/sha1.cpp
        src/formats/rar/unrar/threadpool.cpp
        src/formats/rar/unrar/crc.cpp
        src/formats/rar/unrar/hash.cpp
        src/formats/rar/unrar/strlist.cpp
        src/formats/rar/unrar/rs16.cpp
        src/formats/rar/unrar/resource.cpp
        src/formats/rar/unrar/consio.cpp
        src/formats/rar/unrar/secpassword.cpp
        src/formats/rar/unrar/qopen.cpp
        src/formats/rar/unrar/recvol.cpp
        src/formats/rar/unrar/rijndael.cpp
        src/formats/rar/unrar/timefn.cpp
        src/formats/rar/unrar/encname.cpp
        src/formats/rar/unrar/rawread.cpp
        src/formats/rar/unrar/file.cpp
        src/formats/rar/unrar/strfn.cpp
        src/formats/rar/unrar/sha256.cpp
        src/formats/rar/unrar/filefn.cpp
        src/formats/rar/unrar/filcreat.cpp
        src/formats/rar/unrar/headers.cpp
        src/formats/rar/unrar/blake2s.cpp
        src/formats/rar/unrar/options.cpp
        src/formats/rar/unrar/volume.cpp
        src/formats/rar/unrar/system.cpp
        src/formats/rar/unrar/crypt.cpp
        src/formats/rar/unrar/cmddata.cpp
        src/formats/rar/unrar/extinfo.cpp
        src/formats/rar/unrar/filestr.cpp
        src/formats/rar/unrar/ui.cpp
        src/formats/rar/unrar/list.cpp
        src/formats/rar/unrar/find.cpp
        src/formats/rar/unrar/smallfn.cpp
        src/formats/rar/unrar/unicode.cpp
        src/formats/rar/unrar/pathfn.cpp
        src/formats/rar/unrar/global.cpp
        src/formats/rar/unrar/rarvm.cpp
        src/formats/rar/unrar/getbits.cpp
        src/formats/rar/unrar/rs.cpp
        src/formats/rar/unrar/errhnd.cpp
        src/formats/rar/unrar/archive.cpp
        src/formats/rar/unrar/dll.cpp
        src/formats/rar/unrar/extract.cpp
        src/formats/rar/unrar/match.cpp
        src/formats/rar/unrar/unpack.cpp
        src/formats/rar/unrar/arcread.cpp
        src/formats/rar/unrar/rdwrfn.cpp
        src/formats/rar/unrar/rarpch.cpp
        src/formats/rar/unrar/rar.cpp
        src/formats/rar/unrar/largepage.cpp
    )
    set(SOURCES ${SOURCES} ${RAR_FILES})
endif()

set(SOURCES
    ${SOURCES}
    src/formats/custom/custom.cpp
)

if(LibArchive_FOUND)
    set(SOURCES
        ${SOURCES}
        src/formats/libarch/libarch_utils.cpp
        src/formats/libarch/libarch_crutches.cpp
        src/formats/libarch/libarch_cmd_read.cpp
        src/formats/libarch/libarch_cmd_write.cpp
        src/formats/libarch/libarch.cpp
    )
else()
    set(SOURCES
        ${SOURCES}
        src/formats/targz/targz.cpp
        src/formats/cab/cab.cpp

    )
endif()

add_library (multiarc MODULE ${SOURCES})

target_compile_definitions(multiarc PRIVATE -D_7ZIP_ST -D_7ZIP_PPMD_SUPPPORT)

target_link_libraries(multiarc utils far2l)

if(NOT UNRAR)
    if (LibArchive_FOUND)
        message(STATUS "Using LibArchive for limited RAR archives support.")
    else()
        message(STATUS "${ColorRed}RAR archives support disabled due to UNRAR=${UNRAR} and lack of LibArchive.${ColorNormal}")
    endif()

elseif("${UNRAR}" STREQUAL "lib")
    message(STATUS "Using system unrar - will need libunrar and unrar tool.")
    find_package(Unrar REQUIRED)
    target_include_directories(multiarc PRIVATE ${UNRAR_INCLUDE_DIR})
    target_compile_definitions(multiarc PRIVATE -DRARDLL -DHAVE_UNRAR)
    target_link_libraries(multiarc ${UNRAR_LIBRARIES})
else()
    message(STATUS "Using bundled unrar sources")
    target_include_directories(multiarc PRIVATE src/formats/rar/unrar)
    target_compile_definitions(multiarc PRIVATE -DRARDLL -DHAVE_UNRAR)
    # hide rar warnings in release build
    if(NOT ${CMAKE_BUILD_TYPE} MATCHES Debug)
        set_source_files_properties(${RAR_FILES} PROPERTIES COMPILE_FLAGS
            "-Wno-unknown-warning-option -Wno-parentheses -Wno-switch -Wno-unused-variable -Wno-unused-but-set-variable -Wno-sign-compare -Wno-class-memaccess -Wno-catch-value -Wno-misleading-indentation -Wno-missing-braces")
    endif()
endif()

target_include_directories(multiarc PRIVATE src)
target_include_directories(multiarc PRIVATE ../WinPort)
target_include_directories(multiarc PRIVATE ../far2l/far2sdk)

if(LibArchive_FOUND)
    target_compile_definitions(multiarc PRIVATE -DHAVE_LIBARCHIVE)
    target_link_libraries(multiarc ${LibArchive_LIBRARIES})
    target_include_directories(multiarc PRIVATE ${LibArchive_INCLUDE_DIRS})
endif()

set_target_properties(multiarc
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/multiarc/plug"
        PREFIX ""
        SUFFIX ".far-plug-mb")

# copy resource files
set(CURRENT_TARGET "multiarc")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== netcfg/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)

project(netcfg)

get_directory_property(PROJECT_SOURCE_DIR DIRECTORY ../ DEFINITION PROJECT_SOURCE_DIR)
get_directory_property(INSTALL_DIR DIRECTORY ${PROJECT_SOURCE_DIR} DEFINITION INSTALL_DIR)

message(STATUS "${PROJECT_NAME} PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR} ${CMAKE_SYSTEM_NAME}")

set(SOURCES
netcfgplugin.cpp
netif/netif.cpp
netif/netifs.cpp
netroute/netroute.cpp
netroute/netroutes.cpp
fardialog.cpp
netcfgplugin.cpp
netcfginterfaces.cpp
netcfgroutes.cpp
netcfgiproutes.cpp
netcfgarp.cpp
farpanel.cpp
netfarpanel.cpp
plugincfg.cpp
farconnect.cpp
common/errname.c
common/log.c
common/netutils.c
common/sizestr.c
)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
set(SOURCES
${SOURCES}
netcfgiptables.cpp
netcfgrules.cpp
netcfgarp.cpp
common/netlink.c
)
endif()

set(CMAKE_CXX_STANDARD 17)
#set(CMAKE_C_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# GCC 6+ has a warning for an ABI change due to a bug introduced in GCC 5:
# http://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728. As we are building all of
# drcachesim and not linking to other C++ code, we can just ignore it.
if (ARM AND CMAKE_COMPILER_IS_GNUCC)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG(-Wno-psabi GCC_HAS_NO_PSABI)
    if (GCC_HAS_NO_PSABI)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
    endif (GCC_HAS_NO_PSABI)
endif ()

add_library(${PROJECT_NAME} MODULE ${SOURCES})
target_link_libraries(${PROJECT_NAME} utils far2l)

target_compile_definitions(${PROJECT_NAME} PRIVATE -DUSEUCD=OFF -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(${PROJECT_NAME} PRIVATE .)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/utils/include)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/far2l/far2sdk)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/WinPort)

set_target_properties(${PROJECT_NAME}
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/${PROJECT_NAME}/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/${PROJECT_NAME}"
)

=== processes/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)

project(processes)

get_directory_property(PROJECT_SOURCE_DIR DIRECTORY ../ DEFINITION PROJECT_SOURCE_DIR)
get_directory_property(INSTALL_DIR DIRECTORY ${PROJECT_SOURCE_DIR} DEFINITION INSTALL_DIR)

message(STATUS "${PROJECT_NAME} PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR} ${CMAKE_SYSTEM_NAME}")

set(SOURCES
farconnect.cpp
fardialog.cpp
farpanel.cpp
plugincfg.cpp
plugin.cpp
farapi.cpp
progress.cpp
procplugin.cpp
procpanel.cpp
process/sockets.cpp
process/process.cpp
process/processes.cpp
common/errname.c
common/log.c
common/sizestr.c
common/utf8util.c
common/procutil.c
)


set(CMAKE_CXX_STANDARD 17)
#set(CMAKE_C_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# GCC 6+ has a warning for an ABI change due to a bug introduced in GCC 5:
# http://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728. As we are building all of
# drcachesim and not linking to other C++ code, we can just ignore it.
if (ARM AND CMAKE_COMPILER_IS_GNUCC)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG(-Wno-psabi GCC_HAS_NO_PSABI)
    if (GCC_HAS_NO_PSABI)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
    endif (GCC_HAS_NO_PSABI)
endif ()

add_library(${PROJECT_NAME} MODULE ${SOURCES})
target_link_libraries(${PROJECT_NAME} utils far2l)

target_compile_definitions(${PROJECT_NAME} PRIVATE -DUSEUCD=OFF -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(${PROJECT_NAME} PRIVATE .)
target_include_directories(${PROJECT_NAME} PRIVATE ./process)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/utils/include)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/far2l/far2sdk)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/far2l/Include)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/WinPort)

set_target_properties(${PROJECT_NAME}
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/${PROJECT_NAME}/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/${PROJECT_NAME}"
)

=== sqlite/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.0)

project(sqlplugin)

get_directory_property(PROJECT_SOURCE_DIR DIRECTORY ../ DEFINITION PROJECT_SOURCE_DIR)
get_directory_property(INSTALL_DIR DIRECTORY ${PROJECT_SOURCE_DIR} DEFINITION INSTALL_DIR)

message(STATUS "${PROJECT_NAME} PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR} ${CMAKE_SYSTEM_NAME}")

set(SOURCES
farconnect.cpp
fardialog.cpp
farpanel.cpp
plugincfg.cpp
plugin.cpp
farapi.cpp
sqlplugin.cpp
sqlitepanel.cpp
sqlitepaneldb.cpp
sqlitepaneltable.cpp
sqlitepanelquery.cpp
progress.cpp
exporter.cpp
editor.cpp
common/errname.c
common/log.c
common/sizestr.c
common/utf8util.c
sqlite/engine/sqlite3.c
sqlite/sqlitedb.cpp
)


set(CMAKE_CXX_STANDARD 17)
#set(CMAKE_C_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# GCC 6+ has a warning for an ABI change due to a bug introduced in GCC 5:
# http://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728. As we are building all of
# drcachesim and not linking to other C++ code, we can just ignore it.
if (ARM AND CMAKE_COMPILER_IS_GNUCC)
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG(-Wno-psabi GCC_HAS_NO_PSABI)
    if (GCC_HAS_NO_PSABI)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
    endif (GCC_HAS_NO_PSABI)
endif ()

add_library(${PROJECT_NAME} MODULE ${SOURCES})
target_link_libraries(${PROJECT_NAME} utils far2l)

target_compile_definitions(${PROJECT_NAME} PRIVATE -DUSEUCD=OFF -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(${PROJECT_NAME} PRIVATE .)
target_include_directories(${PROJECT_NAME} PRIVATE ./sqlite)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/utils/include)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/far2l/far2sdk)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/far2l/Include)
target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_SOURCE_DIR}/WinPort)

set_target_properties(sqlplugin
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/${PROJECT_NAME}/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

add_custom_command(TARGET sqlplugin POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/${PROJECT_NAME}"
)

=== debian/changelog ===
far2l-core (2.6.5-1) unstable; urgency=low

  * Bump version to 2.6.5
  * Del key now clears input in elevation dialog
  * Merge pull request #2701 from ctapmex/schemes-update
  * update changelog
  * colorer schemes v1.2.0.62
  * support paste from clipboard in elevation dialog (fix #2688)
  * Merge branch 'master' of github.com:elfmz/far2l
  * stricter unix socket servers permissions
  * Merge pull request #2700 from exkrexpexfex/master
  * Handling mulribyte characters on path abbreviation
  * refactor recent changes
  * yet more tweaks for libarchive detection under mac
  * wx: fix 1sec input reaction delay after adhoc text copying
  * Merge branch 'master' of github.com:elfmz/far2l
  * multiarc/libarch: check if unicode precomposed versions of names matching when comparing filenames for extraction (touch #2613 #2696)
  * Merge pull request #2695 from exkrexpexfex/master
  * Merge pull request #2694 from akruphi/show_uid_gid
  * fix (yet again) libarchive detection on macos
  * Setattr: ability to show "uname"/"gname" or "uid: uname"/"gid: gname"
  * Reapply VMenu filter on Show() if enabled
  * Merge pull request #2692 from spnethw/fix_2588_more_accurate_adjustment_of_LeftPos_in_Viewer
  * Merge pull request #2691 from akruphi/highlighting
  * fix #2588: more accurate adjustment of LeftPos in Viewer
  * Refactoring AddDupWrap() via StrSizeOfCells()
  * Add view by F3 with wrap long line of masks for "Groups of file masks"
  * Arrange elements of dialog "Highlight files - Marking" more logically
  * Files highlighting tuning after #2690
  * Merge pull request #2690 from akruphi/highlighting_def_use_groups
  * Merge pull request #2686 from ctapmex/ubuntu2004-deprecated
  * Merge pull request #2685 from ctapmex/colorer_up
  * Merge pull request #2684 from mitya57/screenshots
  * Merge pull request #2683 from unxed/revert
  * Show in Files highlighting brief dialog with file masks after expand all masks groups
  * new ExMessager::AddDupWrap() for dumb wrap long string
  * Use Mask Groups in defaults of Files highlighting
  * ci: change gcc7 build test
  * update changelog.md
  * Add screenshots also to the README
  * Add screenshots to AppStream metadata
  * fix base catalog search
  * sync colorer with upstream;
  * Revert #2643
  * Merge pull request #2631 from mitya57/metainfo
  * Merge pull request #2679 from spnethw/hlf_update_and_cleanup_4
  * Merge pull request #2681 from m32/master
  * Merge pull request #2678 from mitya57/gcc-15
  * Merge pull request #2682 from akruphi/readme
  * readme + minor
  * proper value
  * in sync with far
  * sending information about keys state should be invisible for marco recording
  * hlf: update and cleanup (4)
  * Add missing <cstdint> include for uint16_t, to fix build with GCC 15
  * Add AppStream metainfo file
  * Merge pull request #2627 from akruphi/changelog
  * Merge pull request #2676 from atolismesh/master
  * Merge pull request #2675 from m32/master
  * Merge pull request #2677 from akruphi/cosmetics
  * Cosmetics help & menu
  * refactoring, use runlike library to recover command line
  * refactoring and bugs
  * refactoring
  * missing loop
  * Fix issue #2668: Multiarc ignores archives if the archive file name does not have an extension - update arcread.cpp
  * refactoring
  * Merge pull request #2673 from akruphi/prevent_blinking
  * prevent blinking in attributes and flags dialogs
  * Merge pull request #2651 from Dazzar56/auto-locale-fix
  * Merge pull request #2671 from Syutkin/patch-1
  * actualization after 15-16 Feb
  * Fix copy/paste AWSSDK_FOUND
  * Merge pull request #2621 from versus-13/netrocks-awss3-plugin
  * Merge pull request #2656 from spnethw/setattr_bugfixes
  * Merge remote-tracking branch 'upstream/master' into auto-locale-fix
  * Merge pull request #2643 from unxed/homekey
  * Merge pull request #2633 from akruphi/fix2082
  * Merge pull request #2619 from spnethw/ConfigClassicHotkeyLinkResolving
  * Merge pull request #2669 from mitya57/fix-duplicate-line
  * Merge pull request #2649 from unxed/kitty_plus
  * build.yml: Remove duplicate libarchive-dev line
  * Merge pull request #2645 from unxed/xterm_shift_fix
  * Merge pull request #2667 from m32/master
  * Merge pull request #2626 from spvkgn/inside
  * try fix ci
  * TTY|F: fix clipboard access dialog missing repaints (fix #2634)
  * Enable C++17
  * Merge pull request #2650 from unxed/multiarc_fix
  * Merge pull request #2612 from spnethw/fix_2605_files_highlighting_and_sort_groups_bugs
  * Merge pull request #2614 from akruphi/misc
  * Update HACKING.md
  * using api for panels
  * utility functions
  * inadequate function name
  * api for editor functions
  * progressdialog
  * testing ID generator
  * using panel api class
  * handlink keditor input callback
  * Fix build on my system
  * can be open also in dialgs
  * correct function declaration
  * correct function declaration, api for panel functions
  * some functions from libc.so
  * python api for panel handling
  * keyboard state for full screen dialogs like hexeditor
  * Merge branch 'elfmz:master' into kitty_plus
  * Merge branch 'kitty_plus' of https://github.com/unxed/far2l into kitty_plus
  * minor fix
  * inside: minor
  * Merge pull request #2620 from akruphi/size_column_width_revert_to_6
  * Merge pull request #2635 from michaellukashov/internal-command-line-improvements
  * Merge pull request #2624 from spnethw/config_cpp_supported_tweaks_fix_wrong_flag
  * Merge pull request #2637 from m32/master
  * Merge pull request #2652 from atolismesh/master
  * Merge pull request #2611 from peter15914/fix_clipboard_null_deref
  * Merge pull request #2610 from spnethw/hlf_update_and_cleanup_3
  * Merge pull request #2609 from akruphi/readme_help
  * Merge branch 'elfmz:master' into homekey
  * Merge branch 'elfmz:master' into xterm_shift_fix
  * Merge branch 'elfmz:master' into multiarc_fix
  * Merge branch 'elfmz:master' into kitty_plus
  * Merge pull request #2600 from anta999/colortest2


=== debian/control ===
Source: far2l-core
Section: Productivity
Priority: optional
Maintainer: viklequick@github.com
Homepage: https://github.com/elfmz/far2l.git
Standards-Version: 4.4.1
Build-Depends: cmake, dpkg, binutils, devscripts, xz-utils, zstd,
               debhelper-compat (= 12),
               dh-exec,
               dh-python,
               g++,
               awk,
               m4,
               make,
               libarchive-dev,
               pkg-config,
               python3-dev,
               python3,
               libxml2-dev,
               libneon27-dev,
               libssl-dev,
               libuchardet-dev,
               libnfs-dev,
               libsmbclient-dev,
               libssh-dev,
               libmtp-dev,
               python3-cffi, python3-pip, 
               aws-sdk-cpp-s3-dev, libaws-sdk-cpp-s3,
               libwxgtk3.2-dev | libwxgtk3.0-gtk3-dev
Rules-Requires-Root: binary-targets

Package: far2l-core
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: bash, libarchive13, libuchardet0, libxml2
Recommends: far2l-ttyxi, far2l-plugins-netrocks-ftp, far2l-plugins-netrocks-sftp, far2l-plugins-netrocks-shell
Suggests: far2l-wxgtk, far2l-plugins-netrocks-smb, far2l-plugins-netrocks-webdav, far2l-plugins-netrocks-nfs,
			tar, gzip, bzip2, exif, 7zip, zstd, elfutils, gpg, util-linux,
          	chafa, jp2a, pandoc, poppler-utils, colordiff, catdoc, universal-ctags, fdisk, rpm, dpkg
Description: Far for Linux main files with core plug-ins, needs terminal to work
 .
 Far 2 Linux is enhanced port of the well-known dual-panel console file manager from the Windows world. Despite to the original, 
 the far 2 Linux has started from the nearly original code from Eugene Roshal and it is based upon FAR 2 codebase but not FAR 3. 
 .
 In addition, Linux version supports both X11 and console modes, with over-ssh access to the clipboard and fully-working keyboard 
 rather than ancient termcap limitations. It introduces background operations for copying, live console scrolling and many other 
 features have implemented in Linux version. Couple of well-known plug-ins are available out of the box, including 
 Colorer, archiving, and network operations.


Package: far2l-ttyxi
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: libxi6, far2l-core
Description: Far for Linux extension to support enhanced keyboard (for case it have started inside X session)

Package: far2l-wxgtk
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libwxbase3.2-1, libwxgtk3.2-1
Description: Far for Linux UI for X11 on top of wxWidgets and GTK

Package: far2l-plugins-netrocks-ftp
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libssl3 | libssl1.1
Description: Far for Linux plug-in to communicate via FTP, as part of NetRocks

Package: far2l-plugins-netrocks-sftp
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libssh2-1, libssl3 | libssl1.1
Description: Far for Linux plug-in to communicate via sFTP, as part of NetRocks

Package: far2l-plugins-netrocks-smb
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libsmbclient
Description: Far for Linux plug-in to communicate via SMB, as part of NetRocks

Package: far2l-plugins-netrocks-webdav
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libneon27
Description: Far for Linux plug-in to communicate via WebDAV, as part of NetRocks

Package: far2l-plugins-netrocks-nfs
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libnfs13
Description: Far for Linux plug-in to communicate via NFS, as part of NetRocks

Package: far2l-plugins-netrocks-shell
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in to communicate via FISH protocol, as part of NetRocks

Package: far2l-plugins-netrocks-aws-s3
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libaws-sdk-cpp-s3
Description: Far for Linux plug-in to communicate with AWS S3 buckets, as part of NetRocks

Package: far2l-plugins-netcfg
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in to manage network interfaces, separate plug-in with MIT license from https://github.com/VPROFi/netcfgplugin

Package: far2l-plugins-hexitor
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in to edit files in hex firm (HEX editor)

Package: far2l-plugins-openwith
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in provides OpenWith.. menu

Package: far2l-plugins-adb
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in to work with adb command line in friendly manner (be sure adb is installed and is available in PATH)

Package: far2l-plugins-mtp
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in provides MTP support

Package: far2l-plugins-sqlite
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, libsqlite3-0
Build-Depends: sqlite3-dev
Description: Far for Linux plug-in to manage SQLite files, separate plug-in with MIT license from https://github.com/VPROFi/sqlplugin

Package: far2l-plugins-processes
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in to manage Linux processes, separate plug-in with MIT license from https://github.com/VPROFi/processes

Package: far2l-plugins-python
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, python3
Build-Depends: python3, python3-cffi, python3-pip
Description: Far for Linux plug-in to support Python plug-ins support, with extra samples inside

Package: far2l-plugins-jumpword
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux plug-in to navigate the definition of the word under cursor (in forward and backward direction), like IDE doing. 

Package: far2l-plugins-editwrap
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core
Description: Far for Linux editor plug-in to wrap long lines. Warning: it is sample plug-in and it uses whole text editor area despite of the selection

Package: far2l-plugins-arclite
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, lib7zz
Description: Far for Linux plug-in to support archives as an addition to standard MultiArc approach.

Package: far2l-server
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, far2l-ttyxi, far2l-plugins-netrocks-ftp, far2l-plugins-netrocks-sftp, far2l-plugins-netrocks-shell
Description: Far for Linux (server-based minimal configuration; use desktop if you looking for confortable environment instead)

Package: far2l-desktop
Multi-Arch: same
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: far2l-core, far2l-ttyxi, far2l-wxgtk, 
				far2l-plugins-netrocks-ftp, far2l-plugins-netrocks-nfs, far2l-plugins-netrocks-sftp,
                far2l-plugins-netrocks-shell, far2l-plugins-netrocks-smb, far2l-plugins-netrocks-webdav,
                far2l-plugins-netcfg, far2l-plugins-processes, far2l-plugins-sqlite, far2l-plugins-hexitor,
                far2l-plugins-openwith, far2l-plugins-arclite
Suggests: far2l-plugins-python, far2l-plugins-netrocks-aws-s3, far2l-plugins-adb, far2l-plugins-mtp
Description: Far for Linux (desktop-ready extended configuration)

=== debian/rules ===
#!/usr/bin/make -f
DESTDIR = $(CURDIR)/debian/tmp

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

export PYSHORT=python3
export PYTHON=$(shell which $(PYSHORT))
export PYTHON_CONFIG="$(PYTHON)-config"

%:
	dh $* $(BUILD_PACKAGES)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DUSEWX=yes -DPYTHON=yes \
		-DEDITOR_JUMPWORD=yes -DEDITOR_EDITWRAP=yes \
		-DNETCFG=yes -DSQLITEPLUGIN=yes -DPROCPLUGIN=yes \
		-DARCLITE=yes \
        -DHEXITOR=yes \
        -DOPENWITH=yes \
        -DU_ADB=yes \
        -DU_MTP=yes \
		-DCMAKE_BUILD_TYPE=Release

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_missing:
	dh_missing --fail-missing
